//
//  UIDevice+Memory.swift
//  DeviceKit
//
//  Created by Ling Wang on 4/11/16.
//
//

import UIKit

@objc
public extension UIDevice {

  func getTaskInfo() -> task_basic_info {
    var info = task_basic_info()
    var infoSize = mach_msg_type_number_t(MemoryLayout<task_basic_info>.size / MemoryLayout<natural_t>.size)
    withUnsafeMutablePointer(to: &info) { infoPointer in
      infoPointer.withMemoryRebound(to: integer_t.self, capacity: MemoryLayout<task_basic_info>.size / MemoryLayout<integer_t>.size) {
        let result = task_info(mach_task_self_, task_flavor_t(TASK_BASIC_INFO), $0, &infoSize)
        if result != KERN_SUCCESS {
          print("Failed to get task info: \(result)")
        }
      }
    }
    return info
  }
  
}
